org.apache.commons.io.output

## Class AbstractByteArrayOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - org.apache.commons.io.output.AbstractByteArrayOutputStream

- All Implemented Interfaces:
    Closeable, Flushable, AutoCloseable
  Direct Known Subclasses:
    ByteArrayOutputStream, UnsynchronizedByteArrayOutputStream

      public abstract class AbstractByteArrayOutputStream
      extends OutputStream

  This is the base class for implementing an output stream in which the data is written into a byte array. The buffer automatically grows as data is written to it.

  The data can be retrieved using `toByteArray()` and `toString()`. Closing an `AbstractByteArrayOutputStream` has no effect. The methods in this class can be called after the stream has been closed without generating an `IOException`.

  This is the base for an alternative implementation of the `ByteArrayOutputStream` class. The original implementation only allocates 32 bytes at the beginning. As this class is designed for heavy duty it starts at bytes. In contrast to the original it doesn't reallocate the whole memory block but allocates additional buffers. This way no buffers need to be garbage collected and the contents don't have to be copied to the new buffer. This class is designed to behave exactly like the original. The only exception is the deprecated `ByteArrayOutputStream.toString(int)` method that has been ignored.

  Since:
    2.7

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static interface` | `AbstractByteArrayOutputStream.InputStreamConstructor<T extends InputStream>` Constructor for an InputStream subclass.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `count` The total count of bytes written.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractByteArrayOutputStream()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Closing a `ByteArrayOutputStream` has no effect.
    `protected void` | `needNewBuffer(int newcount)` Makes a new buffer available either by allocating a new one or re-cycling an existing one.
    `abstract void` | `reset()`
    `protected void` | `resetImpl()`
    `abstract int` | `size()` Returns the current size of the byte array.
    `abstract byte[]` | `toByteArray()` Gets the current contents of this byte stream as a byte array.
    `protected byte[]` | `toByteArrayImpl()` Gets the current contents of this byte stream as a byte array.
    `abstract InputStream` | `toInputStream()` Gets the current contents of this byte stream as a Input Stream.
    `protected <T extends InputStream> InputStream` | `toInputStream(AbstractByteArrayOutputStream.InputStreamConstructor<T> isConstructor)` Gets the current contents of this byte stream as a Input Stream.
    `String` | `toString()` Deprecated. 2.5 use `toString(String)` instead
    `String` | `toString(Charset charset)` Gets the current contents of this byte stream as a string using the specified encoding.
    `String` | `toString(String enc)` Gets the current contents of this byte stream as a string using the specified encoding.
    `abstract void` | `write(byte[] b, int off, int len)` Writes the bytes to the byte array.
    `abstract int` | `write(InputStream in)` Writes the entire contents of the specified input stream to this byte stream.
    `abstract void` | `write(int b)` Write a byte to byte array.
    `protected void` | `writeImpl(byte[] b, int off, int len)` Writes the bytes to the byte array.
    `protected int` | `writeImpl(InputStream in)` Writes the entire contents of the specified input stream to this byte stream.
    `protected void` | `writeImpl(int b)` Write a byte to byte array.
    `abstract void` | `writeTo(OutputStream out)` Writes the entire contents of this byte stream to the specified output stream.
    `protected void` | `writeToImpl(OutputStream out)` Writes the entire contents of this byte stream to the specified output stream.

    - ### Methods inherited from class java.io.OutputStream

      `flush, write`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### count

          protected int count

      The total count of bytes written.

  - ### Constructor Detail

    - #### AbstractByteArrayOutputStream

          public AbstractByteArrayOutputStream()

  - ### Method Detail

    - #### needNewBuffer

          protected void needNewBuffer(int newcount)

      Makes a new buffer available either by allocating a new one or re-cycling an existing one.
      Parameters:
        `newcount` - the size of the buffer if one is created

    - #### write

          public abstract void write(byte[] b,
                                     int off,
                                     int len)

      Writes the bytes to the byte array.
      Overrides:
        `write` in class `OutputStream`
      Parameters:
        `b` - the bytes to write
        `off` - The start offset
        `len` - The number of bytes to write

    - #### writeImpl

          protected void writeImpl(byte[] b,
                                   int off,
                                   int len)

      Writes the bytes to the byte array.
      Parameters:
        `b` - the bytes to write
        `off` - The start offset
        `len` - The number of bytes to write

    - #### write

          public abstract void write(int b)

      Write a byte to byte array.
      Specified by:
        `write` in class `OutputStream`
      Parameters:
        `b` - the byte to write

    - #### writeImpl

          protected void writeImpl(int b)

      Write a byte to byte array.
      Parameters:
        `b` - the byte to write

    - #### write

          public abstract int write(InputStream in)
                             throws IOException

      Writes the entire contents of the specified input stream to this byte stream. Bytes from the input stream are read directly into the internal buffers of this streams.
      Parameters:
        `in` - the input stream to read from
      Returns:
        total number of bytes read from the input stream (and written to this stream)
      Throws:
        `IOException` - if an I/O error occurs while reading the input stream
      Since:
        1.4

    - #### writeImpl

          protected int writeImpl(InputStream in)
                           throws IOException

      Writes the entire contents of the specified input stream to this byte stream. Bytes from the input stream are read directly into the internal buffers of this streams.
      Parameters:
        `in` - the input stream to read from
      Returns:
        total number of bytes read from the input stream (and written to this stream)
      Throws:
        `IOException` - if an I/O error occurs while reading the input stream
      Since:
        2.7

    - #### size

          public abstract int size()

      Returns the current size of the byte array.
      Returns:
        the current size of the byte array

    - #### close

          public void close()
                     throws IOException

      Closing a `ByteArrayOutputStream` has no effect. The methods in this class can be called after the stream has been closed without generating an `IOException`.
      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Overrides:
        `close` in class `OutputStream`
      Throws:
        `IOException` - never (this method should not declare this exception but it has to now due to backwards compatibility)

    - #### reset

          public abstract void reset()

      See Also:
        `ByteArrayOutputStream.reset()`

    - #### resetImpl

          protected void resetImpl()

      See Also:
        `ByteArrayOutputStream.reset()`

    - #### writeTo

          public abstract void writeTo(OutputStream out)
                                throws IOException

      Writes the entire contents of this byte stream to the specified output stream.
      Parameters:
        `out` - the output stream to write to
      Throws:
        `IOException` - if an I/O error occurs, such as if the stream is closed
      See Also:
        `ByteArrayOutputStream.writeTo(OutputStream)`

    - #### writeToImpl

          protected void writeToImpl(OutputStream out)
                              throws IOException

      Writes the entire contents of this byte stream to the specified output stream.
      Parameters:
        `out` - the output stream to write to
      Throws:
        `IOException` - if an I/O error occurs, such as if the stream is closed
      See Also:
        `ByteArrayOutputStream.writeTo(OutputStream)`

    - #### toInputStream

          public abstract InputStream toInputStream()

      Gets the current contents of this byte stream as a Input Stream. The returned stream is backed by buffers of `this` stream, avoiding memory allocation and copy, thus saving space and time.
      Returns:
        the current contents of this output stream.
      Since:
        2.5
      See Also:
        `ByteArrayOutputStream.toByteArray()`, `reset()`

    - #### toInputStream

          protected <T extends InputStream> InputStream toInputStream(AbstractByteArrayOutputStream.InputStreamConstructor<T> isConstructor)

      Gets the current contents of this byte stream as a Input Stream. The returned stream is backed by buffers of `this` stream, avoiding memory allocation and copy, thus saving space and time.
      Type Parameters:
        `T` - the type of the InputStream which makes up the `SequenceInputStream`.
      Parameters:
        `isConstructor` - A constructor for an InputStream which makes up the `SequenceInputStream`.
      Returns:
        the current contents of this output stream.
      Since:
        2.7
      See Also:
        `ByteArrayOutputStream.toByteArray()`, `reset()`

    - #### toByteArray

          public abstract byte[] toByteArray()

      Gets the current contents of this byte stream as a byte array. The result is independent of this stream.
      Returns:
        the current contents of this output stream, as a byte array
      See Also:
        `ByteArrayOutputStream.toByteArray()`

    - #### toByteArrayImpl

          protected byte[] toByteArrayImpl()

      Gets the current contents of this byte stream as a byte array. The result is independent of this stream.
      Returns:
        the current contents of this output stream, as a byte array
      See Also:
        `ByteArrayOutputStream.toByteArray()`

    - #### toString

          @Deprecated
          public String toString()

      Deprecated. 2.5 use `toString(String)` instead
      Gets the current contents of this byte stream as a string using the platform default charset.
      Overrides:
        `toString` in class `Object`
      Returns:
        the contents of the byte array as a String
      See Also:
        `ByteArrayOutputStream.toString()`

    - #### toString

          public String toString(String enc)
                          throws UnsupportedEncodingException

      Gets the current contents of this byte stream as a string using the specified encoding.
      Parameters:
        `enc` - the name of the character encoding
      Returns:
        the string converted from the byte array
      Throws:
        `UnsupportedEncodingException` - if the encoding is not supported
      See Also:
        `ByteArrayOutputStream.toString(String)`

    - #### toString

          public String toString(Charset charset)

      Gets the current contents of this byte stream as a string using the specified encoding.
      Parameters:
        `charset` - the character encoding
      Returns:
        the string converted from the byte array
      Since:
        2.5
      See Also:
        `ByteArrayOutputStream.toString(String)`

Copyright © 2002–2020 The Apache Software Foundation. All rights reserved.